## bpftrace 0.8+git60

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(bpftrace)

set(STATIC_LINKING OFF CACHE BOOL "Build bpftrace as a statically linked executable")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

add_compile_options("-std=c++14")
add_compile_options("-Wno-format-security")
#add_compile_options("-Wall")
#add_compile_options("-Wextra")
#add_compile_options("-Wundef")
#add_compile_options("-Wpointer-arith")
#add_compile_options("-Wcast-align")
#add_compile_options("-Wwrite-strings")
#add_compile_options("-Wcast-qual")
#add_compile_options("-Wswitch-default")
#add_compile_options("-Wswitch-enum")
#add_compile_options("-Wconversion")
#add_compile_options("-Wunreachable-code")
#add_compile_options("-Wformat=2")
#add_compile_options("-Wstrict-overflow=5")
#add_compile_options("-Wdisabled-optimization")

include(CTest)

if (STATIC_LINKING)
  set(CMAKE_EXE_LINKER_FLAGS "-static")
  set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
  set(CMAKE_LINK_SEARCH_START_STATIC TRUE)
  set(CMAKE_LINK_SEARCH_END_STATIC TRUE)
endif()

set(FIND_LIBRARY_USE_LIB64_PATHS TRUE)

find_package(LibBcc REQUIRED)
include_directories(${LIBBCC_INCLUDE_DIRS})

find_package(LibElf REQUIRED)
include_directories(${LIBELF_INCLUDE_DIRS})

find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)
bison_target(bison_parser src/parser.yy ${CMAKE_BINARY_DIR}/parser.tab.cc)
flex_target(flex_lexer src/lexer.l ${CMAKE_BINARY_DIR}/lex.yy.cc)
add_flex_bison_dependency(flex_lexer bison_parser)
add_library(parser ${BISON_bison_parser_OUTPUTS} ${FLEX_flex_lexer_OUTPUTS})
target_include_directories(parser PUBLIC src src/ast ${CMAKE_BINARY_DIR})

include(CheckSymbolExists)
set(CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)
check_symbol_exists(name_to_handle_at "sys/types.h;sys/stat.h;fcntl.h" HAVE_NAME_TO_HANDLE_AT)
set(CMAKE_REQUIRED_DEFINITIONS)

set(CMAKE_REQUIRED_LIBRARIES bcc)
check_symbol_exists(bcc_prog_load "${LIBBCC_INCLUDE_DIRS}/libbpf.h" HAVE_BCC_PROG_LOAD)
check_symbol_exists(bcc_create_map "${LIBBCC_INCLUDE_DIRS}/libbpf.h" HAVE_BCC_CREATE_MAP)

find_package(LLVM REQUIRED)
include_directories(${LLVM_INCLUDE_DIRS})
add_definitions(${LLVM_DEFINITIONS})

find_package(Clang REQUIRED)
include_directories(${CLANG_INCLUDE_DIRS})

add_subdirectory(src/arch)
add_subdirectory(src/ast)
add_subdirectory(src)
if (BUILD_TESTING)
	add_subdirectory(tests)
endif()
add_subdirectory(resources)
add_subdirectory(tools)
add_subdirectory(man)

=== src/CMakeLists.txt ===
add_executable(bpftrace
  attached_probe.cpp
  bpftrace.cpp
  clang_parser.cpp
  driver.cpp
  fake_map.cpp
  main.cpp
  map.cpp
  mapkey.cpp
  printf.cpp
  resolve_cgroupid.cpp
  tracepoint_format_parser.cpp
  types.cpp
  utils.cpp
  list.cpp
)

if(HAVE_NAME_TO_HANDLE_AT)
  target_compile_definitions(bpftrace PRIVATE HAVE_NAME_TO_HANDLE_AT=1)
endif(HAVE_NAME_TO_HANDLE_AT)
if(HAVE_BCC_PROG_LOAD)
  target_compile_definitions(bpftrace PRIVATE HAVE_BCC_PROG_LOAD)
endif(HAVE_BCC_PROG_LOAD)
if(HAVE_BCC_CREATE_MAP)
  target_compile_definitions(bpftrace PRIVATE HAVE_BCC_CREATE_MAP)
endif(HAVE_BCC_CREATE_MAP)
target_link_libraries(bpftrace arch ast parser resources)

if (STATIC_LINKING)
  target_link_libraries(bpftrace ${LIBBCC_LIBRARIES})
  target_link_libraries(bpftrace ${LIBBPF_LIBRARY_STATIC})
  target_link_libraries(bpftrace ${LIBBCC_LOADER_LIBRARY_STATIC})
else()
  target_link_libraries(bpftrace ${LIBBCC_LIBRARIES})
endif()
target_link_libraries(bpftrace ${LIBELF_LIBRARIES})

install(TARGETS bpftrace DESTINATION bin)

set(KERNEL_HEADERS_DIR "" CACHE PATH "Hard-code kernel headers directory")
if (KERNEL_HEADERS_DIR)
MESSAGE(STATUS "Using KERNEL_HEADERS_DIR=${KERNEL_HEADERS_DIR}")
target_compile_definitions(bpftrace PUBLIC KERNEL_HEADERS_DIR="${KERNEL_HEADERS_DIR}")
endif()

execute_process(
  COMMAND git describe --abbrev=4 --dirty --always --tags
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE BPFTRACE_VERSION
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

add_definitions("-DBPFTRACE_VERSION=\"${BPFTRACE_VERSION}\"")

=== tests/CMakeLists.txt ===
add_compile_options("-Wno-undef")
add_compile_options("-Wno-switch-default")
add_compile_options("-Wno-switch-enum")

add_executable(bpftrace_test
  ast.cpp
  bpftrace.cpp
  clang_parser.cpp
  codegen.cpp
  main.cpp
  parser.cpp
  probe.cpp
  semantic_analyser.cpp
  tracepoint_format_parser.cpp
  utils.cpp

  ${CMAKE_SOURCE_DIR}/src/attached_probe.cpp
  ${CMAKE_SOURCE_DIR}/src/bpftrace.cpp
  ${CMAKE_SOURCE_DIR}/src/clang_parser.cpp
  ${CMAKE_SOURCE_DIR}/src/driver.cpp
  ${CMAKE_SOURCE_DIR}/src/fake_map.cpp
  ${CMAKE_SOURCE_DIR}/src/map.cpp
  ${CMAKE_SOURCE_DIR}/src/mapkey.cpp
  ${CMAKE_SOURCE_DIR}/src/printf.cpp
  ${CMAKE_SOURCE_DIR}/src/resolve_cgroupid.cpp
  ${CMAKE_SOURCE_DIR}/src/tracepoint_format_parser.cpp
  ${CMAKE_SOURCE_DIR}/src/types.cpp
  ${CMAKE_SOURCE_DIR}/src/utils.cpp
)

if(HAVE_NAME_TO_HANDLE_AT)
  target_compile_definitions(bpftrace_test PRIVATE HAVE_NAME_TO_HANDLE_AT=1)
endif(HAVE_NAME_TO_HANDLE_AT)
if(HAVE_BCC_PROG_LOAD)
  target_compile_definitions(bpftrace_test PRIVATE HAVE_BCC_PROG_LOAD)
endif(HAVE_BCC_PROG_LOAD)
if(HAVE_BCC_CREATE_MAP)
  target_compile_definitions(bpftrace_test PRIVATE HAVE_BCC_CREATE_MAP)
endif(HAVE_BCC_CREATE_MAP)
target_link_libraries(bpftrace_test arch ast parser resources)

if (STATIC_LINKING)
  target_link_libraries(bpftrace_test ${LIBBCC_LIBRARIES})
  target_link_libraries(bpftrace_test ${LIBBPF_LIBRARY_STATIC})
  target_link_libraries(bpftrace_test ${LIBBCC_LOADER_LIBRARY_STATIC})
else()
  target_link_libraries(bpftrace_test ${LIBBCC_LIBRARIES})
endif()
target_link_libraries(bpftrace_test ${LIBELF_LIBRARIES})

find_package(Threads REQUIRED)

if (OFFLINE_BUILDS)
  include(ExternalProject)
  ExternalProject_Add(gtest-git
    GIT_REPOSITORY https://github.com/google/googletest.git
    GIT_TAG release-1.8.1
    STEP_TARGETS build update
    EXCLUDE_FROM_ALL 1
    UPDATE_DISCONNECTED 1
    )
else()
  include(ExternalProject)
  ExternalProject_Add(gtest-git
    GIT_REPOSITORY https://github.com/google/googletest.git
    GIT_TAG release-1.8.1
    STEP_TARGETS build update
    EXCLUDE_FROM_ALL 1
    )
endif()
add_dependencies(bpftrace_test gtest-git-build)
ExternalProject_Get_Property(gtest-git source_dir binary_dir)
target_include_directories(bpftrace_test PUBLIC ${source_dir}/googletest/include)
target_include_directories(bpftrace_test PUBLIC ${source_dir}/googlemock/include)
target_link_libraries(bpftrace_test ${binary_dir}/googlemock/gtest/libgtest.a)
target_link_libraries(bpftrace_test ${binary_dir}/googlemock/gtest/libgtest_main.a)
target_link_libraries(bpftrace_test ${binary_dir}/googlemock/libgmock.a)
target_link_libraries(bpftrace_test ${CMAKE_THREAD_LIBS_INIT})

add_test(NAME bpftrace_test COMMAND bpftrace_test)

configure_file(runtime-tests.sh runtime-tests.sh COPYONLY)
configure_file(main.py main.py COPYONLY)
configure_file(parser.py parser.py COPYONLY)
configure_file(utils.py utils.py COPYONLY)
file(GLOB runtime_tests runtime/*)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/runtime/)
foreach(runtime_test ${runtime_tests})
  configure_file(${runtime_test} ${CMAKE_CURRENT_BINARY_DIR}/runtime/ COPYONLY)
endforeach()
add_custom_target(runtime-tests COMMAND ./runtime-tests.sh)
add_test(NAME runtime_test COMMAND ./runtime-tests.sh)

=== src/arch/CMakeLists.txt ===
add_library(arch x86_64.cpp)

## bpftrace 0.8+git60-gccac69c2239b

=== debian/changelog ===
bpftrace (0.8+git60-gccac69c2239b-2) unstable; urgency=medium

  * d/patches: add patch to avoid optimizing away BEGIN/END trigger
    functions.
  * d/patches: add patch to correctly detect kernel headers.

 -- Vincent Bernat <bernat@debian.org>  Fri, 22 Feb 2019 06:10:27 -0800

bpftrace (0.8+git60-gccac69c2239b-1) unstable; urgency=medium

  * Initial import. Closes: #918120.

 -- Vincent Bernat <bernat@debian.org>  Sun, 03 Feb 2019 12:53:21 +0100

=== debian/control ===
Source: bpftrace
Section: utils
Priority: optional
Maintainer: Vincent Bernat <bernat@debian.org>
Standards-Version: 4.3.0
Build-Depends: bison,
               clang-7,
               cmake,
               debhelper (>= 11),
               flex,
               libbpfcc-dev,
               libclang-7-dev,
               libelf-dev,
               libfl-dev,
               libgmock-dev,
               libgtest-dev,
               llvm-7-dev,
               zlib1g-dev
Homepage: https://github.com/iovisor/bpftrace
Vcs-Git: https://salsa.debian.org/debian/bpftrace.git
Vcs-Browser: https://salsa.debian.org/debian/bpftrace

Package: bpftrace
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: high-level tracing language for Linux eBPF
 BPFtrace is a high-level tracing language for Linux enhanced Berkeley
 Packet Filter (eBPF) available in recent Linux kernels (4.x). BPFtrace
 uses LLVM as a backend to compile scripts to BPF-bytecode and makes
 use of BCC for interacting with the Linux BPF system, as well as
 existing Linux tracing capabilities: kernel dynamic tracing (kprobes),
 user-level dynamic tracing (uprobes), and tracepoints. The BPFtrace
 language is inspired by awk and C, and predecessor tracers such as
 DTrace and SystemTap.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_TESTING:BOOL=OFF

override_dh_auto_install:
	dh_auto_install
	rm -rf debian/bpftrace/usr/share/bpftrace/tools/doc

	# Move binaries to /usr/sbin
	mkdir -p debian/bpftrace/usr/sbin
	mv debian/bpftrace/usr/share/bpftrace/tools/*.bt debian/bpftrace/usr/sbin

	# Fix manual pages to add the .bt suffix
	for eachMan in debian/bpftrace/usr/man/man8/*; do \
	    mv $$eachMan `echo $$eachMan | sed 's+\.8+.bt.8+'`; \
	done
	mv debian/bpftrace/usr/man debian/bpftrace/usr/share/.

## bpftrace 0.9

=== debian/changelog ===
bpftrace (0.9-1) unstable; urgency=medium

  * New upstream release.
  * d/patches: drop all patches, applied upstream.

 -- Vincent Bernat <bernat@debian.org>  Sat, 16 Mar 2019 19:07:56 +0100

## bpftrace 0.9.2

=== debian/changelog ===
bpftrace (0.9.2-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Bernat <bernat@debian.org>  Thu, 01 Aug 2019 09:06:56 +0200

bpftrace (0.9.1-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Bernat <bernat@debian.org>  Wed, 26 Jun 2019 08:31:30 +0200

## bpftrace 0.9.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(bpftrace)

# bpftrace version number components.
set(bpftrace_VERSION_MAJOR 0)
set(bpftrace_VERSION_MINOR 9)
set(bpftrace_VERSION_PATCH 3)

set(STATIC_LINKING OFF CACHE BOOL "Build bpftrace as a statically linked executable")
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

set (CMAKE_CXX_STANDARD 14)
set (CMAKE_CXX_STANDARD_REQUIRED ON)
set (CMAKE_CXX_EXTENSIONS OFF)

add_compile_options("-Wno-format-security")
add_compile_options("-Wall")
add_compile_options("-Wextra")
add_compile_options("-Wundef")
add_compile_options("-Wpointer-arith")
add_compile_options("-Wcast-align")
add_compile_options("-Wwrite-strings")
add_compile_options("-Wcast-qual")
add_compile_options("-Wswitch-default")
#add_compile_options("-Wswitch-enum")
#add_compile_options("-Wconversion")
add_compile_options("-Wunreachable-code")
#add_compile_options("-Wformat=2")
add_compile_options("-Wstrict-overflow=5")
add_compile_options("-Wdisabled-optimization")

include(CTest)

if (STATIC_LINKING)
  set(CMAKE_EXE_LINKER_FLAGS "-static")
  set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
  set(CMAKE_LINK_SEARCH_START_STATIC TRUE)
  set(CMAKE_LINK_SEARCH_END_STATIC TRUE)
endif()

set(FIND_LIBRARY_USE_LIB64_PATHS TRUE)

find_package(LibBcc REQUIRED)
include_directories(SYSTEM ${LIBBCC_INCLUDE_DIRS})

find_package(LibElf REQUIRED)
include_directories(SYSTEM ${LIBELF_INCLUDE_DIRS})

find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)
bison_target(bison_parser src/parser.yy ${CMAKE_BINARY_DIR}/parser.tab.cc VERBOSE)
flex_target(flex_lexer src/lexer.l ${CMAKE_BINARY_DIR}/lex.yy.cc)
add_flex_bison_dependency(flex_lexer bison_parser)
add_library(parser ${BISON_bison_parser_OUTPUTS} ${FLEX_flex_lexer_OUTPUTS})
target_compile_options(parser PRIVATE "-w")
target_include_directories(parser PUBLIC src src/ast ${CMAKE_BINARY_DIR})

include(CheckSymbolExists)
set(CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)
check_symbol_exists(name_to_handle_at "sys/types.h;sys/stat.h;fcntl.h" HAVE_NAME_TO_HANDLE_AT)
set(CMAKE_REQUIRED_DEFINITIONS)

if(POLICY CMP0075)
  cmake_policy(SET CMP0075 NEW)
endif()
set(CMAKE_REQUIRED_LIBRARIES bcc)
get_filename_component(LIBBCC_LIBDIR ${LIBBCC_LIBRARIES} DIRECTORY)
set(CMAKE_REQUIRED_LINK_OPTIONS -L${LIBBCC_LIBDIR})

check_symbol_exists(bcc_prog_load "${LIBBCC_INCLUDE_DIRS}/libbpf.h" HAVE_BCC_PROG_LOAD)
check_symbol_exists(bcc_create_map "${LIBBCC_INCLUDE_DIRS}/libbpf.h" HAVE_BCC_CREATE_MAP)
check_symbol_exists(bcc_elf_foreach_sym "${LIBBCC_INCLUDE_DIRS}/bcc_elf.h" HAVE_BCC_ELF_FOREACH_SYM)
set(CMAKE_REQUIRED_LIBRARIES)
set(CMAKE_REQUIRED_LINK_OPTIONS)

include(CheckTypeSize)
set(CMAKE_EXTRA_INCLUDE_FILES linux/bpf.h)
# This will set HAVE_GET_CURRENT_CGROUP_ID to TRUE or FALSE
check_type_size("BPF_FUNC_get_current_cgroup_id" GET_CURRENT_CGROUP_ID LANGUAGE C)
set(CMAKE_EXTRA_INCLUDE_FILES)

# Some users have multiple versions of llvm installed and would like to specify
# a specific llvm version.
if(${LLVM_REQUESTED_VERSION})
  find_package(LLVM ${LLVM_REQUESTED_VERSION} REQUIRED)
else()
  find_package(LLVM REQUIRED)
endif()

if(${LLVM_VERSION_MAJOR} VERSION_LESS 5)
  message(SEND_ERROR "Unsupported LLVM version found: ${LLVM_INCLUDE_DIRS}")
  message(SEND_ERROR "Specify an LLVM major version using LLVM_REQUESTED_VERSION=<major version>")
endif()

find_package(LibBpf)
find_package(LibBfd)
find_package(LibOpcodes)

if(${LIBBFD_FOUND} AND ${LIBOPCODES_FOUND})
  set(HAVE_BFD_DISASM TRUE)
endif()

include(CheckIncludeFile)
check_include_file("sys/sdt.h" HAVE_SYSTEMTAP_SYS_SDT_H)

include_directories(SYSTEM ${LLVM_INCLUDE_DIRS})
add_definitions(${LLVM_DEFINITIONS})

find_package(Clang REQUIRED)
include_directories(SYSTEM ${CLANG_INCLUDE_DIRS})

add_subdirectory(src/arch)
add_subdirectory(src/ast)
add_subdirectory(src)
if (BUILD_TESTING)
  add_subdirectory(tests)
endif()
add_subdirectory(resources)
add_subdirectory(tools)
add_subdirectory(man)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,18 +1,26 @@
+if(HAVE_BFD_DISASM)
+  set(BFD_DISASM_SRC bfd-disasm.cpp)
+endif()
+
 add_executable(bpftrace
   attached_probe.cpp
   bpftrace.cpp
+  btf.cpp
   clang_parser.cpp
   driver.cpp
   fake_map.cpp
+  list.cpp
   main.cpp
   map.cpp
   mapkey.cpp
+  output.cpp
   printf.cpp
   resolve_cgroupid.cpp
   tracepoint_format_parser.cpp
   types.cpp
   utils.cpp
-  list.cpp
+  disasm.cpp
+  ${BFD_DISASM_SRC}
 )
 
 if(HAVE_NAME_TO_HANDLE_AT)
@@ -24,6 +32,30 @@
 if(HAVE_BCC_CREATE_MAP)
   target_compile_definitions(bpftrace PRIVATE HAVE_BCC_CREATE_MAP)
 endif(HAVE_BCC_CREATE_MAP)
+if(HAVE_BCC_ELF_FOREACH_SYM)
+  target_compile_definitions(bpftrace PRIVATE HAVE_BCC_ELF_FOREACH_SYM)
+endif(HAVE_BCC_ELF_FOREACH_SYM)
+if(HAVE_GET_CURRENT_CGROUP_ID)
+  target_compile_definitions(bpftrace PRIVATE HAVE_GET_CURRENT_CGROUP_ID)
+endif(HAVE_GET_CURRENT_CGROUP_ID)
+if (LIBBPF_BTF_DUMP_FOUND)
+  target_compile_definitions(bpftrace PRIVATE HAVE_LIBBPF_BTF_DUMP)
+  target_include_directories(bpftrace PUBLIC ${LIBBPF_INCLUDE_DIRS})
+  target_link_libraries(bpftrace ${LIBBPF_LIBRARIES})
+endif(LIBBPF_BTF_DUMP_FOUND)
+if(HAVE_BFD_DISASM)
+  target_compile_definitions(bpftrace PRIVATE HAVE_BFD_DISASM)
+  if(LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
+    target_compile_definitions(bpftrace PRIVATE LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
+  endif(LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
+  target_link_libraries(bpftrace ${LIBBFD_LIBRARIES})
+  target_link_libraries(bpftrace ${LIBOPCODES_LIBRARIES})
+endif(HAVE_BFD_DISASM)
+
+if (ALLOW_UNSAFE_UPROBE)
+  target_compile_definitions(bpftrace PRIVATE HAVE_UNSAFE_UPROBE)
+endif(ALLOW_UNSAFE_UPROBE)
+
 target_link_libraries(bpftrace arch ast parser resources)
 
 if (STATIC_LINKING)
@@ -44,10 +76,18 @@
 endif()
 
 execute_process(
-  COMMAND git describe --abbrev=4 --dirty --always --tags
+  COMMAND git describe --abbrev=4 --dirty --tags
   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
   OUTPUT_VARIABLE BPFTRACE_VERSION
+  ERROR_VARIABLE GIT_DESCRIBE_ERROR
   OUTPUT_STRIP_TRAILING_WHITESPACE
+  RESULT_VARIABLE retcode
 )
 
+# If the build is not done from a git repo, get the version information from
+# the version variables in main CMakeLists.txt
+if(NOT "${retcode}" STREQUAL "0")
+  set(BPFTRACE_VERSION "v${bpftrace_VERSION_MAJOR}.${bpftrace_VERSION_MINOR}.${bpftrace_VERSION_PATCH}")
+endif()
+
 add_definitions("-DBPFTRACE_VERSION=\"${BPFTRACE_VERSION}\"")

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,31 +1,53 @@
 add_compile_options("-Wno-undef")
 add_compile_options("-Wno-switch-default")
 add_compile_options("-Wno-switch-enum")
+
+# Combine all codegen tests into a single compilation unit to improve build
+# performance. https://github.com/iovisor/bpftrace/issues/229
+function(generate_codegen_includes output)
+  file(GLOB tests codegen/*.cpp)
+  file(WRITE ${output} "")
+  foreach(test ${tests})
+    file(APPEND ${output} "#include \"${test}\"\n")
+  endforeach()
+endfunction()
+
+if(HAVE_BFD_DISASM)
+  set(BFD_DISASM_SRC ${CMAKE_SOURCE_DIR}/src/bfd-disasm.cpp)
+endif()
+
+generate_codegen_includes(${CMAKE_BINARY_DIR}/tests/codegen_includes.cpp)
 
 add_executable(bpftrace_test
   ast.cpp
   bpftrace.cpp
   clang_parser.cpp
-  codegen.cpp
   main.cpp
+  mocks.cpp
   parser.cpp
   probe.cpp
   semantic_analyser.cpp
   tracepoint_format_parser.cpp
   utils.cpp
 
+  ${CMAKE_BINARY_DIR}/tests/codegen_includes.cpp
+
   ${CMAKE_SOURCE_DIR}/src/attached_probe.cpp
   ${CMAKE_SOURCE_DIR}/src/bpftrace.cpp
+  ${CMAKE_SOURCE_DIR}/src/btf.cpp
   ${CMAKE_SOURCE_DIR}/src/clang_parser.cpp
   ${CMAKE_SOURCE_DIR}/src/driver.cpp
   ${CMAKE_SOURCE_DIR}/src/fake_map.cpp
   ${CMAKE_SOURCE_DIR}/src/map.cpp
   ${CMAKE_SOURCE_DIR}/src/mapkey.cpp
+  ${CMAKE_SOURCE_DIR}/src/output.cpp
   ${CMAKE_SOURCE_DIR}/src/printf.cpp
   ${CMAKE_SOURCE_DIR}/src/resolve_cgroupid.cpp
   ${CMAKE_SOURCE_DIR}/src/tracepoint_format_parser.cpp
   ${CMAKE_SOURCE_DIR}/src/types.cpp
   ${CMAKE_SOURCE_DIR}/src/utils.cpp
+  ${CMAKE_SOURCE_DIR}/src/disasm.cpp
+  ${BFD_DISASM_SRC}
 )
 
 if(HAVE_NAME_TO_HANDLE_AT)
@@ -37,6 +59,23 @@
 if(HAVE_BCC_CREATE_MAP)
   target_compile_definitions(bpftrace_test PRIVATE HAVE_BCC_CREATE_MAP)
 endif(HAVE_BCC_CREATE_MAP)
+if(HAVE_GET_CURRENT_CGROUP_ID)
+  target_compile_definitions(bpftrace PRIVATE HAVE_GET_CURRENT_CGROUP_ID)
+endif(HAVE_GET_CURRENT_CGROUP_ID)
+if (LIBBPF_BTF_DUMP_FOUND)
+  target_compile_definitions(bpftrace_test PRIVATE HAVE_LIBBPF_BTF_DUMP)
+  target_include_directories(bpftrace_test PUBLIC ${LIBBPF_INCLUDE_DIRS})
+  target_link_libraries(bpftrace_test ${LIBBPF_LIBRARIES})
+endif(LIBBPF_BTF_DUMP_FOUND)
+if(HAVE_BFD_DISASM)
+  target_compile_definitions(bpftrace_test PRIVATE HAVE_BFD_DISASM)
+  if(LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
+    target_compile_definitions(bpftrace_test PRIVATE LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
+  endif(LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
+  target_link_libraries(bpftrace_test ${LIBBFD_LIBRARIES})
+  target_link_libraries(bpftrace_test ${LIBOPCODES_LIBRARIES})
+endif(HAVE_BFD_DISASM)
+
 target_link_libraries(bpftrace_test arch ast parser resources)
 
 if (STATIC_LINKING)
@@ -84,9 +123,37 @@
 configure_file(parser.py parser.py COPYONLY)
 configure_file(utils.py utils.py COPYONLY)
 file(GLOB runtime_tests runtime/*)
+list(REMOVE_ITEM runtime_tests ${CMAKE_CURRENT_SOURCE_DIR}/runtime/scripts)
+list(REMOVE_ITEM runtime_tests ${CMAKE_CURRENT_SOURCE_DIR}/runtime/outputs)
 file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/runtime/)
 foreach(runtime_test ${runtime_tests})
   configure_file(${runtime_test} ${CMAKE_CURRENT_BINARY_DIR}/runtime/ COPYONLY)
 endforeach()
+file(GLOB runtime_test_scripts runtime/scripts/*)
+file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/runtime/scripts)
+foreach(runtime_test_script ${runtime_test_scripts})
+  configure_file(${runtime_test_script} ${CMAKE_CURRENT_BINARY_DIR}/runtime/scripts/ COPYONLY)
+endforeach()
+file(GLOB runtime_test_outputs runtime/outputs/*)
+file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/runtime/outputs)
+foreach(runtime_test_output ${runtime_test_outputs})
+  configure_file(${runtime_test_output} ${CMAKE_CURRENT_BINARY_DIR}/runtime/outputs/ COPYONLY)
+endforeach()
 add_custom_target(runtime-tests COMMAND ./runtime-tests.sh)
 add_test(NAME runtime_test COMMAND ./runtime-tests.sh)
+
+# Compile all testprograms, one per .c file for runtime testing
+file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testprogs/)
+file(GLOB testprogs testprogs/*.c)
+foreach(testprog ${testprogs})
+  get_filename_component(bin_name ${testprog} NAME_WE)
+  add_executable (${bin_name} ${testprog})
+  if(HAVE_SYSTEMTAP_SYS_SDT_H)
+    target_compile_definitions(${bin_name} PRIVATE HAVE_SYSTEMTAP_SYS_SDT_H)
+  endif(HAVE_SYSTEMTAP_SYS_SDT_H)
+  set_target_properties( ${bin_name} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testprogs/ COMPILE_FLAGS "-g -O0")
+endforeach()
+
+configure_file(tools-parsing-test.sh tools-parsing-test.sh COPYONLY)
+add_custom_target(tools-parsing-test COMMAND ./tools-parsing-test.sh)
+add_test(NAME tools-parsing-test COMMAND ./tools-parsing-test.sh)

=== debian/changelog ===
bpftrace (0.9.3-2) unstable; urgency=medium

  * Source-only rebuild.

 -- Vincent Bernat <bernat@debian.org>  Sun, 12 Jan 2020 08:13:51 +0100

bpftrace (0.9.3-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Bernat <bernat@debian.org>  Fri, 27 Dec 2019 09:16:59 +0100

bpftrace (0.9.2-3) unstable; urgency=medium

  * d/control: switch to clang 9. Closes: #947436.

 -- Vincent Bernat <bernat@debian.org>  Fri, 27 Dec 2019 09:10:54 +0100

bpftrace (0.9.2-2) unstable; urgency=medium

  * Bump version to rebuild against newer version of libbpfcc.

 -- Vincent Bernat <bernat@debian.org>  Tue, 05 Nov 2019 08:22:07 +0100

## bpftrace 0.9.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,16 +4,39 @@
 # bpftrace version number components.
 set(bpftrace_VERSION_MAJOR 0)
 set(bpftrace_VERSION_MINOR 9)
-set(bpftrace_VERSION_PATCH 3)
+set(bpftrace_VERSION_PATCH 4)
 
+set(WARNINGS_AS_ERRORS OFF CACHE BOOL "Build with -Werror")
 set(STATIC_LINKING OFF CACHE BOOL "Build bpftrace as a statically linked executable")
+set(STATIC_LIBC OFF CACHE BOOL "Attempt to embed libc, only known to work with musl. Has issues with dlopen.")
+set(EMBED_LLVM OFF CACHE BOOL "Build LLVM static libs as an ExternalProject and link to these instead of system libs.")
+set(EMBED_CLANG OFF CACHE BOOL "Build Clang static libs as an ExternalProject and link to these instead of system libs.")
+set(EMBED_LIBCLANG_ONLY OFF CACHE BOOL "Build only libclang.a, and link to system libraries statically")
+set(LLVM_VERSION "8" CACHE STRING "Embedded LLVM/Clang version to build and link against.")
+set(BUILD_ASAN OFF CACHE BOOL "Build bpftrace with -fsanitize=address")
+
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
+
+if(EMBED_LLVM OR EMBED_CLANG)
+  set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/embed)
+  include(embed_helpers)
+  if (NOT STATIC_LINKING)
+    set(CONFIG_ERROR "Dependencies can only be embedded for a static build.\n"
+                     "Enable STATIC_LINKING=ON to embed static libs.")
+    message(FATAL_ERROR ${CONFIG_ERROR})
+  elseif(STATIC_LIBC)
+    message(WARNING "static libc is known to cause problems, consider STATIC_LIBC=OFF. Proceed at your own risk") #iovisor/bpftrace/issues/266
+  endif()
+endif()
+
+if(EMBED_LIBCLANG_ONLY AND NOT EMBED_CLANG)
+    message(FATAL_ERROR "Cannot set EMBED_LIBCLANG_ONLY without also setting EMBED_CLANG")
+endif()
 
 set (CMAKE_CXX_STANDARD 14)
 set (CMAKE_CXX_STANDARD_REQUIRED ON)
 set (CMAKE_CXX_EXTENSIONS OFF)
 
-add_compile_options("-Wno-format-security")
 add_compile_options("-Wall")
 add_compile_options("-Wextra")
 add_compile_options("-Wundef")
@@ -26,17 +49,28 @@
 #add_compile_options("-Wconversion")
 add_compile_options("-Wunreachable-code")
 #add_compile_options("-Wformat=2")
-add_compile_options("-Wstrict-overflow=5")
 add_compile_options("-Wdisabled-optimization")
+
+if (WARNINGS_AS_ERRORS)
+  add_compile_options("-Werror")
+endif()
 
 include(CTest)
 
-if (STATIC_LINKING)
-  set(CMAKE_EXE_LINKER_FLAGS "-static")
+if(STATIC_LINKING)
+  if(STATIC_LIBC)
+    set(CMAKE_EXE_LINKER_FLAGS "-static")
+  elseif(EMBED_LLVM OR EMBED_CLANG)
+    set(EMBEDDED_LINK_FLAGS "-static-libgcc -static-libstdc++ -Wl,--start-group")
+    set(EMBEDDED_LINK_FLAGS "${EMBEDDED_LINK_FLAGS} -Wl,-Bdynamic -lrt")
+    set(EMBEDDED_LINK_FLAGS "${EMBEDDED_LINK_FLAGS} -Wl,-Bdynamic -lpthread")
+    set(EMBEDDED_LINK_FLAGS "${EMBEDDED_LINK_FLAGS} -Wl,-Bdynamic -ldl -lm")
+    set(EMBEDDED_LINK_FLAGS "${EMBEDDED_LINK_FLAGS} -Wl,-Bstatic -lz")
+  endif(STATIC_LIBC)
   set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
   set(CMAKE_LINK_SEARCH_START_STATIC TRUE)
   set(CMAKE_LINK_SEARCH_END_STATIC TRUE)
-endif()
+endif(STATIC_LINKING)
 
 set(FIND_LIBRARY_USE_LIB64_PATHS TRUE)
 
@@ -73,25 +107,6 @@
 set(CMAKE_REQUIRED_LIBRARIES)
 set(CMAKE_REQUIRED_LINK_OPTIONS)
 
-include(CheckTypeSize)
-set(CMAKE_EXTRA_INCLUDE_FILES linux/bpf.h)
-# This will set HAVE_GET_CURRENT_CGROUP_ID to TRUE or FALSE
-check_type_size("BPF_FUNC_get_current_cgroup_id" GET_CURRENT_CGROUP_ID LANGUAGE C)
-set(CMAKE_EXTRA_INCLUDE_FILES)
-
-# Some users have multiple versions of llvm installed and would like to specify
-# a specific llvm version.
-if(${LLVM_REQUESTED_VERSION})
-  find_package(LLVM ${LLVM_REQUESTED_VERSION} REQUIRED)
-else()
-  find_package(LLVM REQUIRED)
-endif()
-
-if(${LLVM_VERSION_MAJOR} VERSION_LESS 5)
-  message(SEND_ERROR "Unsupported LLVM version found: ${LLVM_INCLUDE_DIRS}")
-  message(SEND_ERROR "Specify an LLVM major version using LLVM_REQUESTED_VERSION=<major version>")
-endif()
-
 find_package(LibBpf)
 find_package(LibBfd)
 find_package(LibOpcodes)
@@ -103,11 +118,32 @@
 include(CheckIncludeFile)
 check_include_file("sys/sdt.h" HAVE_SYSTEMTAP_SYS_SDT_H)
 
-include_directories(SYSTEM ${LLVM_INCLUDE_DIRS})
-add_definitions(${LLVM_DEFINITIONS})
+if (EMBED_LLVM)
+  include(embed_llvm)
+else()
+  # Some users have multiple versions of llvm installed and would like to specify
+  # a specific llvm version.
+  if(${LLVM_REQUESTED_VERSION})
+    find_package(LLVM ${LLVM_REQUESTED_VERSION} REQUIRED)
+  else()
+    find_package(LLVM REQUIRED)
+  endif()
 
-find_package(Clang REQUIRED)
-include_directories(SYSTEM ${CLANG_INCLUDE_DIRS})
+  if(${LLVM_VERSION_MAJOR} VERSION_LESS 5)
+    message(SEND_ERROR "Unsupported LLVM version found: ${LLVM_INCLUDE_DIRS}")
+    message(SEND_ERROR "Specify an LLVM major version using LLVM_REQUESTED_VERSION=<major version>")
+  endif()
+
+  include_directories(SYSTEM ${LLVM_INCLUDE_DIRS})
+  add_definitions(${LLVM_DEFINITIONS})
+endif()
+
+if(EMBED_CLANG)
+  include(embed_clang)
+else()
+  find_package(Clang REQUIRED)
+  include_directories(SYSTEM ${CLANG_INCLUDE_DIRS})
+endif()
 
 add_subdirectory(src/arch)
 add_subdirectory(src/ast)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,9 +4,11 @@
 
 add_executable(bpftrace
   attached_probe.cpp
+  bpffeature.cpp
   bpftrace.cpp
   btf.cpp
   clang_parser.cpp
+  disasm.cpp
   driver.cpp
   fake_map.cpp
   list.cpp
@@ -16,10 +18,11 @@
   output.cpp
   printf.cpp
   resolve_cgroupid.cpp
+  signal.cpp
+  struct.cpp
   tracepoint_format_parser.cpp
   types.cpp
   utils.cpp
-  disasm.cpp
   ${BFD_DISASM_SRC}
 )
 
@@ -35,9 +38,6 @@
 if(HAVE_BCC_ELF_FOREACH_SYM)
   target_compile_definitions(bpftrace PRIVATE HAVE_BCC_ELF_FOREACH_SYM)
 endif(HAVE_BCC_ELF_FOREACH_SYM)
-if(HAVE_GET_CURRENT_CGROUP_ID)
-  target_compile_definitions(bpftrace PRIVATE HAVE_GET_CURRENT_CGROUP_ID)
-endif(HAVE_GET_CURRENT_CGROUP_ID)
 if (LIBBPF_BTF_DUMP_FOUND)
   target_compile_definitions(bpftrace PRIVATE HAVE_LIBBPF_BTF_DUMP)
   target_include_directories(bpftrace PUBLIC ${LIBBPF_INCLUDE_DIRS})
@@ -48,31 +48,61 @@
   if(LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
     target_compile_definitions(bpftrace PRIVATE LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
   endif(LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
-  target_link_libraries(bpftrace ${LIBBFD_LIBRARIES})
-  target_link_libraries(bpftrace ${LIBOPCODES_LIBRARIES})
+  if(STATIC_LINKING)
+    add_library(LIBBFD STATIC IMPORTED)
+    set_property(TARGET LIBBFD PROPERTY IMPORTED_LOCATION ${LIBBFD_LIBRARIES})
+    target_link_libraries(bpftrace LIBBFD)
+    add_library(LIBOPCODES STATIC IMPORTED)
+    set_property(TARGET LIBOPCODES PROPERTY IMPORTED_LOCATION ${LIBOPCODES_LIBRARIES})
+    target_link_libraries(bpftrace LIBOPCODES)
+    add_library(LIBIBERTY STATIC IMPORTED)
+    set_property(TARGET LIBIBERTY PROPERTY IMPORTED_LOCATION ${LIBIBERTY_LIBRARIES})
+    target_link_libraries(bpftrace LIBIBERTY)
+  else()
+    target_link_libraries(bpftrace ${LIBBFD_LIBRARIES})
+    target_link_libraries(bpftrace ${LIBOPCODES_LIBRARIES})
+  endif(STATIC_LINKING)
 endif(HAVE_BFD_DISASM)
 
-if (ALLOW_UNSAFE_UPROBE)
-  target_compile_definitions(bpftrace PRIVATE HAVE_UNSAFE_UPROBE)
-endif(ALLOW_UNSAFE_UPROBE)
+if (ALLOW_UNSAFE_PROBE)
+  target_compile_definitions(bpftrace PRIVATE HAVE_UNSAFE_PROBE)
+endif(ALLOW_UNSAFE_PROBE)
 
 target_link_libraries(bpftrace arch ast parser resources)
 
-if (STATIC_LINKING)
+if(STATIC_LINKING)
   target_link_libraries(bpftrace ${LIBBCC_LIBRARIES})
   target_link_libraries(bpftrace ${LIBBPF_LIBRARY_STATIC})
   target_link_libraries(bpftrace ${LIBBCC_LOADER_LIBRARY_STATIC})
+
+  add_library(LIBELF STATIC IMPORTED)
+  set_property(TARGET LIBELF PROPERTY IMPORTED_LOCATION ${LIBELF_LIBRARIES})
+  target_link_libraries(bpftrace LIBELF)
+
+  if(NOT STATIC_LIBC)
+    set_target_properties(bpftrace PROPERTIES LINK_FLAGS "${EMBEDDED_LINK_FLAGS}")
+  endif()
 else()
   target_link_libraries(bpftrace ${LIBBCC_LIBRARIES})
+  target_link_libraries(bpftrace ${LIBELF_LIBRARIES})
+endif(STATIC_LINKING)
+
+if (BUILD_ASAN)
+  if(${CMAKE_VERSION} VERSION_LESS "3.13.0")
+    # target_link_options is supported in CMake 3.13 and newer
+    message("Please use CMake 3.13 or newer to enable ASAN")
+  endif()
+  target_compile_definitions(bpftrace PRIVATE BUILD_ASAN)
+  target_compile_options(bpftrace PUBLIC "-fsanitize=address")
+  target_link_options(bpftrace PUBLIC "-fsanitize=address")
 endif()
-target_link_libraries(bpftrace ${LIBELF_LIBRARIES})
 
 install(TARGETS bpftrace DESTINATION bin)
 
 set(KERNEL_HEADERS_DIR "" CACHE PATH "Hard-code kernel headers directory")
 if (KERNEL_HEADERS_DIR)
-MESSAGE(STATUS "Using KERNEL_HEADERS_DIR=${KERNEL_HEADERS_DIR}")
-target_compile_definitions(bpftrace PUBLIC KERNEL_HEADERS_DIR="${KERNEL_HEADERS_DIR}")
+  MESSAGE(STATUS "Using KERNEL_HEADERS_DIR=${KERNEL_HEADERS_DIR}")
+  target_compile_definitions(bpftrace PUBLIC KERNEL_HEADERS_DIR="${KERNEL_HEADERS_DIR}")
 endif()
 
 execute_process(

=== tests/CMakeLists.txt ===
add_compile_options("-Wno-undef")
add_compile_options("-Wno-switch-default")
add_compile_options("-Wno-switch-enum")

# Combine all codegen tests into a single compilation unit to improve build
# performance. https://github.com/iovisor/bpftrace/issues/229
function(generate_codegen_includes output)
  file(GLOB tests codegen/*.cpp)
  file(WRITE ${output} "")
  foreach(test ${tests})
    file(APPEND ${output} "#include \"${test}\"\n")
  endforeach()
endfunction()

if(HAVE_BFD_DISASM)
  set(BFD_DISASM_SRC ${CMAKE_SOURCE_DIR}/src/bfd-disasm.cpp)
endif()

generate_codegen_includes(${CMAKE_BINARY_DIR}/tests/codegen_includes.cpp)

add_executable(bpftrace_test
  ast.cpp
  bpftrace.cpp
  clang_parser.cpp
  main.cpp
  mocks.cpp
  parser.cpp
  probe.cpp
  semantic_analyser.cpp
  tracepoint_format_parser.cpp
  utils.cpp

  ${CMAKE_BINARY_DIR}/tests/codegen_includes.cpp

  ${CMAKE_SOURCE_DIR}/src/attached_probe.cpp
  ${CMAKE_SOURCE_DIR}/src/bpftrace.cpp
  ${CMAKE_SOURCE_DIR}/src/bpffeature.cpp
  ${CMAKE_SOURCE_DIR}/src/btf.cpp
  ${CMAKE_SOURCE_DIR}/src/clang_parser.cpp
  ${CMAKE_SOURCE_DIR}/src/disasm.cpp
  ${CMAKE_SOURCE_DIR}/src/driver.cpp
  ${CMAKE_SOURCE_DIR}/src/fake_map.cpp
  ${CMAKE_SOURCE_DIR}/src/map.cpp
  ${CMAKE_SOURCE_DIR}/src/mapkey.cpp
  ${CMAKE_SOURCE_DIR}/src/output.cpp
  ${CMAKE_SOURCE_DIR}/src/printf.cpp
  ${CMAKE_SOURCE_DIR}/src/resolve_cgroupid.cpp
  ${CMAKE_SOURCE_DIR}/src/signal.cpp
  ${CMAKE_SOURCE_DIR}/src/struct.cpp
  ${CMAKE_SOURCE_DIR}/src/tracepoint_format_parser.cpp
  ${CMAKE_SOURCE_DIR}/src/types.cpp
  ${CMAKE_SOURCE_DIR}/src/utils.cpp
  ${BFD_DISASM_SRC}
)

if(HAVE_NAME_TO_HANDLE_AT)
  target_compile_definitions(bpftrace_test PRIVATE HAVE_NAME_TO_HANDLE_AT=1)
endif(HAVE_NAME_TO_HANDLE_AT)
if(HAVE_BCC_PROG_LOAD)
  target_compile_definitions(bpftrace_test PRIVATE HAVE_BCC_PROG_LOAD)
endif(HAVE_BCC_PROG_LOAD)
if(HAVE_BCC_CREATE_MAP)
  target_compile_definitions(bpftrace_test PRIVATE HAVE_BCC_CREATE_MAP)
endif(HAVE_BCC_CREATE_MAP)
if (LIBBPF_BTF_DUMP_FOUND)
  target_compile_definitions(bpftrace_test PRIVATE HAVE_LIBBPF_BTF_DUMP)
  target_include_directories(bpftrace_test PUBLIC ${LIBBPF_INCLUDE_DIRS})
  target_link_libraries(bpftrace_test ${LIBBPF_LIBRARIES})
endif(LIBBPF_BTF_DUMP_FOUND)
if(HAVE_BFD_DISASM)
  target_compile_definitions(bpftrace_test PRIVATE HAVE_BFD_DISASM)
  if(LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
    target_compile_definitions(bpftrace_test PRIVATE LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
  endif(LIBBFD_DISASM_FOUR_ARGS_SIGNATURE)
  if(STATIC_LINKING)
    add_library(LIBBFD STATIC IMPORTED)
    set_property(TARGET LIBBFD PROPERTY IMPORTED_LOCATION ${LIBBFD_LIBRARIES})
    target_link_libraries(bpftrace_test LIBBFD)
    add_library(LIBOPCODES STATIC IMPORTED)
    set_property(TARGET LIBOPCODES PROPERTY IMPORTED_LOCATION ${LIBOPCODES_LIBRARIES})
    target_link_libraries(bpftrace_test LIBOPCODES)
    add_library(LIBIBERTY STATIC IMPORTED)
    set_property(TARGET LIBIBERTY PROPERTY IMPORTED_LOCATION ${LIBIBERTY_LIBRARIES})
    target_link_libraries(bpftrace_test LIBIBERTY)
  else()
    target_link_libraries(bpftrace_test ${LIBBFD_LIBRARIES})
    target_link_libraries(bpftrace_test ${LIBOPCODES_LIBRARIES})
  endif(STATIC_LINKING)
endif(HAVE_BFD_DISASM)

target_link_libraries(bpftrace_test arch ast parser resources)

if (STATIC_LINKING)
  if(EMBED_LLVM OR EMBED_CLANG)
    set_target_properties(bpftrace_test PROPERTIES LINK_FLAGS "${EMBEDDED_LINK_FLAGS}")
  endif()

  target_link_libraries(bpftrace_test ${LIBBCC_LIBRARIES})
  target_link_libraries(bpftrace_test ${LIBBPF_LIBRARY_STATIC})
  target_link_libraries(bpftrace_test ${LIBBCC_LOADER_LIBRARY_STATIC})

  add_library(LIBELF STATIC IMPORTED)
  set_property(TARGET LIBELF PROPERTY IMPORTED_LOCATION ${LIBELF_LIBRARIES})
  target_link_libraries(bpftrace_test LIBELF)
else()
  target_link_libraries(bpftrace_test ${LIBBCC_LIBRARIES})
  target_link_libraries(bpftrace_test ${LIBELF_LIBRARIES})
endif(STATIC_LINKING)

find_package(Threads REQUIRED)

# Ninja build system needs the byproducts set explicilty so it can
# check for missing dependencies.
# https://cmake.org/pipermail/cmake/2015-April/060234.html
set(gtest_byproducts
  <BINARY_DIR>/googlemock/gtest/libgtest.a
  <BINARY_DIR>/googlemock/gtest/libgtest_main.a
  <BINARY_DIR>/googlemock/libgmock.a
)
include(ExternalProject)
if (OFFLINE_BUILDS)
  ExternalProject_Add(gtest-git
    GIT_REPOSITORY https://github.com/google/googletest.git
    GIT_TAG release-1.8.1
    STEP_TARGETS build update
    EXCLUDE_FROM_ALL 1
    UPDATE_DISCONNECTED 1
    BUILD_BYPRODUCTS ${gtest_byproducts}
    )
else()
  ExternalProject_Add(gtest-git
    GIT_REPOSITORY https://github.com/google/googletest.git
    GIT_TAG release-1.8.1
    STEP_TARGETS build update
    EXCLUDE_FROM_ALL 1
    BUILD_BYPRODUCTS ${gtest_byproducts}
    )
endif()
add_dependencies(bpftrace_test gtest-git-build)
ExternalProject_Get_Property(gtest-git source_dir binary_dir)
target_include_directories(bpftrace_test PUBLIC ${source_dir}/googletest/include)
target_include_directories(bpftrace_test PUBLIC ${source_dir}/googlemock/include)
target_link_libraries(bpftrace_test ${binary_dir}/googlemock/gtest/libgtest.a)
target_link_libraries(bpftrace_test ${binary_dir}/googlemock/gtest/libgtest_main.a)
target_link_libraries(bpftrace_test ${binary_dir}/googlemock/libgmock.a)
if(NOT STATIC_LINKING)
  target_link_libraries(bpftrace_test ${CMAKE_THREAD_LIBS_INIT})
endif(NOT STATIC_LINKING)

add_test(NAME bpftrace_test COMMAND bpftrace_test)

# Compile all testprograms, one per .c file for runtime testing
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testprogs/)
file(GLOB testprogs testprogs/*.c)
set(compiled_testprogs "")
foreach(testprog ${testprogs})
  get_filename_component(bin_name ${testprog} NAME_WE)
  add_executable (${bin_name} ${testprog})
  if(HAVE_SYSTEMTAP_SYS_SDT_H)
    target_compile_definitions(${bin_name} PRIVATE HAVE_SYSTEMTAP_SYS_SDT_H)
  endif(HAVE_SYSTEMTAP_SYS_SDT_H)
  set_target_properties( ${bin_name} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testprogs/ COMPILE_FLAGS "-g -O0" LINK_FLAGS "-no-pie")
  list(APPEND compiled_testprogs ${CMAKE_CURRENT_BINARY_DIR}/testprogs/${bin_name})
endforeach()
add_custom_target(testprogs DEPENDS ${compiled_testprogs})

# Similarly compile all test libs
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testlibs/)
file(GLOB testlibs testlibs/*.c)
set(compiled_testlibs "")
foreach(testlib_source ${testlibs})
  get_filename_component(testlib_name ${testlib_source} NAME_WE)
  add_library(${testlib_name} SHARED ${testlib_source})
  set_target_properties(${testlib_name} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testlibs/ COMPILE_FLAGS "-g -O0")
  # clear the executable bit
  add_custom_command(TARGET ${testlib_name}
    POST_BUILD
    COMMAND chmod -x ${CMAKE_CURRENT_BINARY_DIR}/testlibs/lib${testlib_name}.so)
  list(APPEND compiled_testlibs ${CMAKE_CURRENT_BINARY_DIR}/testlibs/lib${testlib_name}.so)
endforeach()
add_custom_target(testlibs DEPENDS ${compiled_testlibs})

configure_file(runtime-tests.sh runtime-tests.sh COPYONLY)
file(GLOB runtime_tests runtime/*)
list(REMOVE_ITEM runtime_tests ${CMAKE_CURRENT_SOURCE_DIR}/runtime/engine)
list(REMOVE_ITEM runtime_tests ${CMAKE_CURRENT_SOURCE_DIR}/runtime/scripts)
list(REMOVE_ITEM runtime_tests ${CMAKE_CURRENT_SOURCE_DIR}/runtime/outputs)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/runtime/)
foreach(runtime_test ${runtime_tests})
  configure_file(${runtime_test} ${CMAKE_CURRENT_BINARY_DIR}/runtime/ COPYONLY)
endforeach()
file(GLOB runtime_engine_files runtime/engine/*)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/runtime/engine)
foreach(runtime_engine_file ${runtime_engine_files})
  configure_file(${runtime_engine_file} ${CMAKE_CURRENT_BINARY_DIR}/runtime/engine/ COPYONLY)
endforeach()
file(GLOB runtime_test_scripts runtime/scripts/*)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/runtime/scripts)
foreach(runtime_test_script ${runtime_test_scripts})
  configure_file(${runtime_test_script} ${CMAKE_CURRENT_BINARY_DIR}/runtime/scripts/ COPYONLY)
endforeach()
file(GLOB runtime_test_outputs runtime/outputs/*)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/runtime/outputs)
foreach(runtime_test_output ${runtime_test_outputs})
  configure_file(${runtime_test_output} ${CMAKE_CURRENT_BINARY_DIR}/runtime/outputs/ COPYONLY)
endforeach()
add_custom_target(
  runtime-tests
  COMMAND ./runtime-tests.sh
  DEPENDS ${compiled_testprogs} ${compiled_testlibs} ${CMAKE_BINARY_DIR}/src/bpftrace
)
add_test(NAME runtime_test COMMAND ./runtime-tests.sh)

configure_file(tools-parsing-test.sh tools-parsing-test.sh COPYONLY)
add_custom_target(tools-parsing-test COMMAND ./tools-parsing-test.sh)
add_test(NAME tools-parsing-test COMMAND ./tools-parsing-test.sh)

=== man/man8/CMakeLists.txt ===
find_program(GZIP gzip)
file(GLOB FILES *.8)
set(GZFILES "")
foreach(FIL ${FILES})
  get_filename_component(NAME ${FIL} NAME)
  add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${NAME}.gz
    COMMAND ${GZIP} -c ${FIL} > ${CMAKE_CURRENT_BINARY_DIR}/${NAME}.gz
    DEPENDS ${FIL})
  list(APPEND GZFILES "${CMAKE_CURRENT_BINARY_DIR}/${NAME}.gz")
endforeach()
add_custom_target(man ALL DEPENDS ${GZFILES})
install(FILES ${GZFILES} DESTINATION man/man8)

=== src/arch/CMakeLists.txt ===
if(CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
    add_library(arch aarch64.cpp)
elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "ppc64" OR
       CMAKE_SYSTEM_PROCESSOR STREQUAL "ppc64le")
    add_library(arch ppc64.cpp)
else()
    add_library(arch x86_64.cpp)
endif()

=== src/ast/CMakeLists.txt ===
add_library(ast
  ast.cpp
  codegen_llvm.cpp
  field_analyser.cpp
  irbuilderbpf.cpp
  printer.cpp
  semantic_analyser.cpp
)

target_include_directories(ast PUBLIC ${CMAKE_SOURCE_DIR}/src)
target_include_directories(ast PUBLIC ${CMAKE_SOURCE_DIR}/src/ast)
target_include_directories(ast PUBLIC ${CMAKE_BINARY_DIR})
target_link_libraries(ast arch)

add_dependencies(ast parser)

if (STATIC_LINKING)
  set(clang_libs
      clangAST
      clangAnalysis
      clangBasic
      clangDriver
      clangEdit
      clangFormat
      clangFrontend
      clangIndex
      clangLex
      clangParse
      clangRewrite
      clangSema
      clangSerialization
      clangToolingCore)

  if(EMBED_CLANG)
    list(APPEND clang_libs clangToolingInclusions)
    if(EMBED_LIBCLANG_ONLY)
      unlink_transitive_dependency("${CLANG_EXPORTED_TARGETS}" "LLVM")
    endif()
    target_link_libraries(ast ${CLANG_EMBEDDED_CMAKE_TARGETS})
  else()
    list(INSERT clang_libs 0 libclang.a)
  endif()

  if(EMBED_LLVM)
    target_link_libraries(ast ${LLVM_EMBEDDED_CMAKE_TARGETS})
  else()
    llvm_map_components_to_libnames(llvm_libs bpfcodegen ipo irreader mcjit orcjit ${LLVM_TARGETS_TO_BUILD})
    target_link_libraries(ast ${clang_libs})
    target_link_libraries(ast ${llvm_libs})
  endif()
else()
  find_library(found_LLVM LLVM HINTS ${LLVM_LIBRARY_DIRS})
  if(found_LLVM)
    target_link_libraries(ast LLVM)
  else()
    llvm_map_components_to_libnames(_llvm_libs bpfcodegen ipo irreader mcjit orcjit ${LLVM_TARGETS_TO_BUILD})
    llvm_expand_dependencies(llvm_libs ${_llvm_libs})
    target_link_libraries(ast ${llvm_libs})
  endif()
  target_link_libraries(ast libclang)
endif()

=== debian/changelog ===
bpftrace (0.9.4-1) unstable; urgency=medium

  * New upstream version.

 -- Vincent Bernat <bernat@debian.org>  Thu, 27 Feb 2020 22:50:17 +0100

=== debian/control ===
--- 
+++ 
@@ -4,17 +4,17 @@
 Maintainer: Vincent Bernat <bernat@debian.org>
 Standards-Version: 4.3.0
 Build-Depends: bison,
-               clang-7,
+               clang-9,
                cmake,
                debhelper (>= 11),
                flex,
                libbpfcc-dev,
-               libclang-7-dev,
+               libclang-9-dev,
                libelf-dev,
                libfl-dev,
                libgmock-dev,
                libgtest-dev,
-               llvm-7-dev,
+               llvm-9-dev,
                zlib1g-dev
 Homepage: https://github.com/iovisor/bpftrace
 Vcs-Git: https://salsa.debian.org/debian/bpftrace.git

## bpftrace 0.11.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,12 @@
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.8)
 project(bpftrace)
 
 # bpftrace version number components.
 set(bpftrace_VERSION_MAJOR 0)
-set(bpftrace_VERSION_MINOR 9)
-set(bpftrace_VERSION_PATCH 4)
+set(bpftrace_VERSION_MINOR 11)
+set(bpftrace_VERSION_PATCH 0)
+
+include(GNUInstallDirs)
 
 set(WARNINGS_AS_ERRORS OFF CACHE BOOL "Build with -Werror")
 set(STATIC_LINKING OFF CACHE BOOL "Build bpftrace as a statically linked executable")
@@ -14,10 +16,12 @@
 set(EMBED_LIBCLANG_ONLY OFF CACHE BOOL "Build only libclang.a, and link to system libraries statically")
 set(LLVM_VERSION "8" CACHE STRING "Embedded LLVM/Clang version to build and link against.")
 set(BUILD_ASAN OFF CACHE BOOL "Build bpftrace with -fsanitize=address")
+set(ENABLE_MAN ON CACHE BOOL "Build man pages")
+set(ENABLE_TEST_VALIDATE_CODEGEN ON CACHE BOOL "Run LLVM IR validation tests")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 
-if(EMBED_LLVM OR EMBED_CLANG)
+if(EMBED_LLVM OR EMBED_CLANG OR STATIC_LIBC)
   set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/embed)
   include(embed_helpers)
   if (NOT STATIC_LINKING)
@@ -33,7 +37,7 @@
     message(FATAL_ERROR "Cannot set EMBED_LIBCLANG_ONLY without also setting EMBED_CLANG")
 endif()
 
-set (CMAKE_CXX_STANDARD 14)
+set (CMAKE_CXX_STANDARD 17)
 set (CMAKE_CXX_STANDARD_REQUIRED ON)
 set (CMAKE_CXX_EXTENSIONS OFF)
 
@@ -74,6 +78,8 @@
 
 set(FIND_LIBRARY_USE_LIB64_PATHS TRUE)
 
+include_directories(SYSTEM ${KERNEL_INCLUDE_DIRS})
+
 find_package(LibBcc REQUIRED)
 include_directories(SYSTEM ${LIBBCC_INCLUDE_DIRS})
 
@@ -97,13 +103,19 @@
 if(POLICY CMP0075)
   cmake_policy(SET CMP0075 NEW)
 endif()
-set(CMAKE_REQUIRED_LIBRARIES bcc)
+if(STATIC_LINKING)
+  set(CMAKE_REQUIRED_LIBRARIES bcc bcc_bpf bpf elf z)
+else()
+  set(CMAKE_REQUIRED_LIBRARIES bcc)
+endif(STATIC_LINKING)
 get_filename_component(LIBBCC_LIBDIR ${LIBBCC_LIBRARIES} DIRECTORY)
 set(CMAKE_REQUIRED_LINK_OPTIONS -L${LIBBCC_LIBDIR})
 
-check_symbol_exists(bcc_prog_load "${LIBBCC_INCLUDE_DIRS}/libbpf.h" HAVE_BCC_PROG_LOAD)
-check_symbol_exists(bcc_create_map "${LIBBCC_INCLUDE_DIRS}/libbpf.h" HAVE_BCC_CREATE_MAP)
-check_symbol_exists(bcc_elf_foreach_sym "${LIBBCC_INCLUDE_DIRS}/bcc_elf.h" HAVE_BCC_ELF_FOREACH_SYM)
+check_symbol_exists(bcc_prog_load "${LIBBCC_INCLUDE_DIRS}/bcc/libbpf.h" HAVE_BCC_PROG_LOAD)
+check_symbol_exists(bcc_create_map "${LIBBCC_INCLUDE_DIRS}/bcc/libbpf.h" HAVE_BCC_CREATE_MAP)
+check_symbol_exists(bcc_elf_foreach_sym "${LIBBCC_INCLUDE_DIRS}/bcc/bcc_elf.h" HAVE_BCC_ELF_FOREACH_SYM)
+check_symbol_exists(bpf_attach_kfunc "${LIBBCC_INCLUDE_DIRS}/bcc/libbpf.h" HAVE_BCC_KFUNC)
+check_symbol_exists(bcc_usdt_addsem_probe "${LIBBCC_INCLUDE_DIRS}/bcc/bcc_usdt.h" HAVE_BCC_USDT_ADDSEM)
 set(CMAKE_REQUIRED_LIBRARIES)
 set(CMAKE_REQUIRED_LINK_OPTIONS)
 
@@ -129,11 +141,12 @@
     find_package(LLVM REQUIRED)
   endif()
 
-  if(${LLVM_VERSION_MAJOR} VERSION_LESS 5)
+  if(${LLVM_VERSION_MAJOR} VERSION_LESS 6)
     message(SEND_ERROR "Unsupported LLVM version found: ${LLVM_INCLUDE_DIRS}")
     message(SEND_ERROR "Specify an LLVM major version using LLVM_REQUESTED_VERSION=<major version>")
   endif()
 
+  message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}: ${LLVM_CMAKE_DIR}")
   include_directories(SYSTEM ${LLVM_INCLUDE_DIRS})
   add_definitions(${LLVM_DEFINITIONS})
 endif()
@@ -153,4 +166,6 @@
 endif()
 add_subdirectory(resources)
 add_subdirectory(tools)
+if (ENABLE_MAN)
 add_subdirectory(man)
+endif(ENABLE_MAN)

=== debian/changelog ===
bpftrace (0.11.0-1) unstable; urgency=medium

  * New upstream version.
  * d/rules: delete empty /usr/share/bpftrace/tools
  * d/rules: don't rename bpftrace manual page
  * d/patches: ensure BEGIN_trigger symbol is not stripped

 -- Vincent Bernat <bernat@debian.org>  Fri, 24 Jul 2020 09:14:50 +0200

bpftrace (0.10.0-1) unstable; urgency=medium

  * New upstream version.
  * d/rules: upstream now puts man pages in their expected locations.

 -- Vincent Bernat <bernat@debian.org>  Mon, 11 May 2020 08:41:18 +0200
